package org.greenstone.gsdl3.service;

import org.w3c.dom.Document; 
import org.w3c.dom.Node; 
import org.w3c.dom.Text; 
import org.w3c.dom.Element; 
import org.w3c.dom.NodeList; 

  
public class MGGDBMService 
    extends ServiceModule {

    /** passes the request Element to the appropriate service function*/
    protected Element processService(String name, Element request) {
	
	// dont need to check that the service name is  supported for this particular object, because that has been checked by ServiceModule
	if (name.equals("TextQuery")) {
	    return processTextQuery(request);
	} else if (name.equals("DocRetrieve")) {
	    return processDocRetrieve(request);
	} else if (name.equals("MetadataRetrieve")) {
	    return processMetadataRetrieve(request);
	}
	
	System.err.println("MGGDBMService:should never get here. service type wrong:"+name);
	return null;
    }
	
    public boolean configure(Element info) {

	System.out.println("configuring MGGDBMService");

	Element e = null;
	// these entries should reflect the build config file - some services may not be available depending on how the colleciton was built.
	// set up short_service_info_ - for now just has name and type
	e = doc_.createElement("service");
	e.setAttribute("type", "query");
	e.setAttribute("name", "TextQuery");
	short_service_info_.appendChild(e);

	e = doc_.createElement("service");
	e.setAttribute("type", "query");
	e.setAttribute("name", "DocRetrieve");
	short_service_info_.appendChild(e);

	e = doc_.createElement("service");
	e.setAttribute("type", "query");
	e.setAttribute("name", "MetadataRetrieve");
	short_service_info_.appendChild(e);


	// set up service_info_map_ - for now, just has the same elements as above
	// should have full details about each service incl params lists etc.
	e = doc_.createElement("service");
	e.setAttribute("type", "query");
	e.setAttribute("name", "TextQuery");
	service_info_map_.put("TextQuery", e);
	
	e = doc_.createElement("service");
	e.setAttribute("type", "query");
	e.setAttribute("name", "DocRetrieve");
	service_info_map_.put("DocRetrieve", e);
	
	e = doc_.createElement("service");
	e.setAttribute("type", "query");
	e.setAttribute("name", "MetadataRetrieve");
	service_info_map_.put("MetadataRetrieve", e);

	return true;
    }
   
    protected Element processTextQuery(Element request) {
	Element result = doc_.createElement("response");
	result.setAttribute("name", "TextQuery");
	
	// dummy result
	Text t = null;
	t = doc_.createTextNode("Textquery result... ");
	result.appendChild(t);
	return result;
    }

    protected Element processDocRetrieve(Element request) {
	Element result = doc_.createElement("response");
	result.setAttribute("name", "DocRetrieve");
	
	// dummy result
	Text t = null;
	t = doc_.createTextNode("DocRetrieve result... ");
	result.appendChild(t);
	return result;
    }

    protected Element processMetadataRetrieve(Element request) {
	Element result = doc_.createElement("response");
	result.setAttribute("name", "MetadataRetrieve");
	
	// dummy result
	Text t = null;
	t = doc_.createTextNode("MetadataRetrieve result... ");
	result.appendChild(t);
	return result;
    }

}   
